#![feature(
    extract_if,
    iter_advance_by,
    box_into_inner,
    hash_extract_if,
    bigint_helper_methods,
    map_try_insert,
    iter_intersperse,
    int_roundings
)]
#![allow(unused_macros)]

pub mod asm;
pub mod ast;
pub mod common;
pub mod comptime;
pub mod error;
//pub mod intern_pool;
pub mod lexer;
pub mod mir;
pub mod parser;
pub mod string_table;
pub mod symbol_table;
pub mod tokens;
pub mod triples;

pub fn tokenize<'a>(
    bytes: &'a [u8],
) -> Result<lexer::Tokenizer<'a>, (lexer::Tokenizer<'a>, Vec<lexer::TokenizeError>)> {
    lexer::Tokenizer::new_with_errors(bytes)
}
